package ObservuPlugins::SystemLoad;

# create a new plugin object
sub new {

    my $class = shift;
    my $self = {
      _config => shift,
      _state => {}
    };
    bless $self, $class;
    #print "created new systemload plugin object\n";
    return $self;

}


# return a hash with all produced metrics
sub produce_data{
  my($self) = @_;
  
  my $data = { 'load:float' => read_load() };
  #print "produced system load data ".$data->{'load:float'}."\n";
  return $data;  
}


# helper method
sub read_load {
   open( my $load_in, "<", "/proc/loadavg");
   if(defined(my $load = <$load_in>)){
     
     if($load =~ /^([0-9\.]+)\s/){
       return 0+$1; 
     }
   }
   close($load_in);
   return -1;
}
