package ObservuPlugins::SystemMemoryUsage;



# create a new plugin object
sub new {
    my $class = shift;
    my $self = {
      _config => shift,
      _state => {}
    };
    bless $self, $class;
    return $self;
}


# return a hash with all produced metrics
sub produce_data{
  my($self) = @_;
  
  return read_memusage();  
}



#
# See http://www.linuxweblog.com/meminfo
#

sub read_memusage{
  my $result = {};
  
   
  open(my $f, "<", "/proc/meminfo");
  
  while(defined(my $line = <$f>)){
    if($line =~ /^MemFree:\s+([0-9]+) kB/){
      $result->{'memory.free:kilobytes'} = $1;
    }elsif($line =~ /^Buffers:\s+([0-9]+) kB/){
      $result->{'memory.buffers:kilobytes'} = $1; 
    }elsif($line =~ /^Cached:\s+([0-9]+) kB/){
      $result->{'memory.cached:kilobytes'} = $1; 
    }elsif($line =~ /^SwapFree:\s+([0-9]+) kB/){
      $result->{'memory.swap_free:kilobytes'} = $1; 
    }
  }
  close($f);
  return $result;
}
